#ifndef	_Allocator_h
#	define	_Allocator_h

#	include	"Stack.h"

template	<class	T>
class	Allocator
	{
	public:
		static	Stack<T	*>	ObjectStack;
#	ifdef	DEBUG_MEMORY
		static	int			NewObjectsOfType;
#	endif
	public:
		static	T	*	New()
			{
			T	*t;

			if ( ObjectStack.GetSize() )
				{
				ObjectStack.Pop(t);
				//memset(t, 0, sizeof(T));
				return( t );
				}
#	ifdef	DEBUG_MEMORY
			DisableMemoryWatch();
			t = new T;
			EnableMemoryWatch();
			++NewObjectsOfType;
#	ifndef	ALLOCATOR_LEAKAGE_THRESHOLD
#	define	ALLOCATOR_LEAKAGE_THRESHOLD	10000
#	endif
			if ( NewObjectsOfType >= ALLOCATOR_LEAKAGE_THRESHOLD )
				{
				FatalError("Probably a memory leak in allocator -- run under a debugger to find type");
				}
			return(t);
#	else
			return ( new T );
#	endif
			}
		static	bool	Delete(T	*t)
			{
#	ifdef	DEBUG_MEMORY
			for(int	Index = 0; Index < ObjectStack.GetSize(); Index++)
				if ( ObjectStack[Index] == t )
					{
					printf("double DELETE of object %x -- dieing with extreme prejudice\n", (unsigned int)t);
					assert(0);
					}
#	endif
			ObjectStack.Push(t);
			return ( true );
			}
	};

#	ifdef	DEBUG_MEMORY

#	define	DEFINE_ALLOCATOR(TTT)	\
	Stack<TTT	*>	Allocator<TTT>::ObjectStack; \
	int				Allocator<TTT>::NewObjectsOfType = 0;

#else

#	define	DEFINE_ALLOCATOR(TTT)	\
	Stack<TTT	*>	Allocator<TTT>::ObjectStack

#	endif

#	define	NEW(TTT)				\
	Allocator<TTT>	::	New()

#	define	DELETE(TTT, aaa)				\
	Allocator<TTT>	::	Delete(aaa)

#	define	__DELETE(TTT, aaa)				\
	Allocator<TTT>	::	Delete(aaa)

#	define	FREELISTSIZE(TTT)	\
	Allocator<TTT>	::	ObjectStack.GetSize()

#	define	SafeDelete(xxx)	if ( xxx ) {delete xxx;}

#endif


